// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

// UE includes
#include "CoreMinimal.h"
#include "GameFramework/CharacterMovementComponent.h"

#include "GSCharacterMovementComponent.generated.h"

/**
 *	Subclass of CharacterMovementComponent which allows for a custom gravity direction to be applied to the character while falling
 */
UCLASS()
class GRAVITYSTOMPGAME_API UGSCharacterMovementComponent : public UCharacterMovementComponent
{
	GENERATED_BODY()

public:
	UGSCharacterMovementComponent();

	virtual void PhysFalling(float deltaTime, int32 Iterations) override;

	UFUNCTION(BlueprintCallable)
	void SetCharacterUpDirection(FVector NewUpDirection);

private:
	FVector CharacterUpDirection = FVector::UpVector;
};
